datablock ItemData(mapItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./mapItem.dts";

	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Map of Jones County";
	iconName = "./vent";
	doColorShift = true;
	colorShiftColor = "0.26 0.26 0.26 1";

	 // Dynamic properties defined by the scripts
	image = mapImage;
	canDrop = true;
};

datablock ShapeBaseImageData(mapImage)
{
   // Basic Item properties
	shapeFile = "./map.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0 0 0";
   correctMuzzleVector = false;
   className = "WeaponImage";
   item = mapItem;
   ammo = " ";
   projectile = "";
   projectileType = "";

   melee = false;
   armReady = true;

   doColorShift = true;
   colorShiftColor = mapItem.colorShiftColor;

	stateName[0] = "Activate";
	stateTimeoutValue[0] = 0.0;
	stateTransitionOnTimeout[0] = "Ready";

	stateName[1] = "Ready";
	stateAllowImageChange[1] = true;
};

function mapImage::onMount(%this, %obj, %slot)
{
	%obj.playthread(2, armReadyBoth);
	Parent::onMount(%this, %obj, %slot);
}

function mapImage::onUnMount(%this, %obj, %slot)
{
	%obj.playthread(2, root);
	Parent::onUnMount(%this, %obj, %slot);
}