datablock StaticShapeData(fakeShapeNameShape)
{
	shapeFile = "base/data/shapes/empty.dts";
};

registerOutputEvent(Bot,"SetAIShapeName","string 50 200" TAB "paintColor 0");

function AIPlayer::SetAIShapeName(%this, %name, %color)
{
	if(isObject(%tag))
	{
		%tag.delete();
	}
	
	%tag = new StaticShape()
	{
		datablock = fakeShapeNameShape;
		position = %this.getPosition();
	};
	
	%tag.setShapeName(%name);
	%color = getColorIDTable(%color);
	%tag.setShapeNameColor(%color);
	setFakeShapeName(%this, %tag);
}

function setFakeShapeName(%this, %tag)
{
	if(isObject(%this))
	{
		if(!isObject(%tag))
		{
			error("Error: No Shape");
		}
		else
		{
			%aipos = %this.getEyeTransform();
			%tag.settransform(%aipos);
			schedule(1,0,setFakeShapeName,%this, %tag);
		}
	}
	else
	{
		%tag.delete();
	}
}

package MinigameAIshapeNamePackage
{
	function MiniGameSO::reset(%this, %client)
	{
		for(%i = 0; %i < missionCleanup.getCount(); %i++)
		{
			%obj = missionCleanup.getObject(%i);
			if(%obj.getClassName() $= "StaticShape")
			{
				if(%obj.getDatablock() == fakeShapeNameShape.getID())
					%obj.delete();
			}
		}
		Parent::reset(%this, %client);
	}
};
activatepackage(MinigameAIshapeNamePackage);