registerOutputEvent("player","mountToVehicle","string 40 100",1);
registerOutputEvent("player","mountToSeat","int 0 24 0",1);
registerOutputEvent("bot","mountToVehicle","string 40 100",1);
registerOutputEvent("bot","mountToSeat","int 0 24 0",1);
package swol_mountToVehicleEvents
{
	function SimObject::processInputEvent(%obj,%eventName,%cl)
	{
		if(isObject(%cl))
			%cl.lastProcessedBrick = %obj;
		return parent::processInputEvent(%obj,%eventName,%cl);
	}
};
activatePackage(swol_mountToVehicleEvents);
function player::mountToVehicle(%pl,%name,%cl)
{
	%bName = getWord(%name,getrandom(0,getWordCount(%name)-1));
	if(%pl.getClassName() $= "AiPlayer")
		%brick = hReturnNamedBrick(%pl.spawnBrick.getGroup(),%bName);
	else if(isObject(%cl.lastProcessedBrick) && isObject(%cl.lastProcessedBrick.getGroup()))
		%brick = hReturnNamedBrick(%cl.lastProcessedBrick.getGroup(),%bName);
	else
		return 0;
	if(!isObject(%veh = %brick.vehicle))
		return 0;
	if(%pl.getObjectMount() == %veh)
		return 1;
	%db = %veh.getDatablock();
	for(%i=0;%i<%db.numMountPoints;%i++)
	{
		if(isObject(%m = %veh.getMountNodeObject(%i)))
		{
			if(!%m.getDatablock().rideable)
				continue;
			if(isObject(%m.getMountNodeObject(0)))
				continue;
			%m.mountObject(%pl,0);
			return 1;
		}
		%veh.mountObject(%pl,%i);
		return 1;
	}
	return 0;
}
function player::mountToSeat(%pl,%slot)
{
	if(!isObject(%veh = %pl.getObjectMount()))
		return 0;
	if(%veh.getClassName() !$= "WheeledVehicle")
		return 0;
	%db = %veh.getDatablock();
	%slot = mClamp(%slot,0,%db.numMountPoints-1);
	if(isObject(%m = %veh.getMountNodeObject(%slot)))
	{
		if(!%m.getDatablock().rideable)
			return 0;
		%veh = %m;
		%slot = 0;
	}
	if(isObject(%m.getMountNodeObject(0)))
		return 0;
	%veh.mountObject(%pl,%slot);
	return 1;
}
//Thanks Rotondo
if(isFunction("hReturnNamedBrick"))
	return;
function hReturnNamedBrick(%brickGroup,%name)
{
	%name = "_" @ %name;
	for(%a = 0; %a < %brickGroup.NTNameCount; %a++)
	{
		if(%brickGroup.NTName[%a] !$= %name || %brickGroup.NTObjectCount[%name] < 0)
			continue;

		%n = %brickGroup.NTObjectCount[%name];

		return %brickGroup.NTObject[%name,getRandom(0,%n-1)];
	}
	return 0;
}