registerOutputEvent(Bot, "canPickupItems", "bool", 0);

function AIPlayer::canPickupItems(%bot, %bool)
{
	%bot.canPickupItems = %bool;
}

package canPickupItems
{
	function ShapeBase::pickup(%obj, %item)
	{
		parent::pickup(%obj, %item);

		if(%obj.getClassName() !$= "AIPlayer" || !%obj.canPickupItems || !%item.canPickup)
		{
			return;
		}

		if(isObject(%obj.getMountedImage(0)))
		{
			if(%item.getDataBlock().image $= %obj.getMountedImage(0).getName())
			{
				return;
			}
		}

		if(isObject(%item.spawnBrick))
		{
			if(isEventPending(%item.spawnBrick.fadeInSchedule))
			{
				return;
			}

			%obj.setWeapon(%item.getDataBlock().getName());

			%item.fadeOut();
			%item.fadeInSchedule = %item.schedule(%item.spawnBrick.itemRespawnTime, fadeIn);
		}

		else
		{
			%obj.setWeapon(%item.getDataBlock().getName());

			%item.canPickup = false;
			%item.delete();
		}
	}
};
activatePackage(canPickupItems);