datablock fxDTSBrickData(BrickVoidSofaData)
{
	category = "Special";
	subCategory = "Misc";
	uiName = "Void Sofa";
	brickFile = "./sofa.blb";
	collisionShapeName = "./sofa.dts";
	iconName = "Add-Ons/Brick_Void/sofa";
};
datablock fxDTSBrickData(BrickVoidChairData)
{
	category = "Special";
	subCategory = "Misc";
	uiName = "Void Chair";
	brickFile = "./chair.blb";
	collisionShapeName = "./chair.dts";
	iconName = "Add-Ons/Brick_Void/chair";
};
datablock fxDTSBrickData(BrickVoidEndTableDataA)
{
	category = "Special";
	subCategory = "Misc";
	uiName = "Void End Table";
	brickFile = "./endtable.blb";
	collisionShapeName = "./endtable.dts";
	iconName = "Add-Ons/Brick_Void/endTable";
};
datablock fxDTSBrickData(BrickVoidLampData)
{
	category = "Special";
	subCategory = "Misc";
	uiName = "Void Lamp";
	brickFile = "./lamp.blb";
	collisionShapeName = "./lamp.dts";
	iconName = "Add-Ons/Brick_Void/lamp";
};
datablock fxDTSBrickData(BrickVoidGrassData)
{
	category = "Special";
	subCategory = "Misc";
	uiName = "Grass";
	brickFile = "./grass.blb";
	iconName = "Add-Ons/Brick_Void/grass";
};
datablock fxDTSBrickData(BrickVoidBambooPotData)
{
	category = "Special";
	subCategory = "Misc";
	uiName = "Bamboo Pot";
	brickFile = "./bamboopot.blb";
	collisionShapeName = "./bambooPot.dts";
	iconName = "Add-Ons/Brick_Void/bamboopot";
};
datablock fxDTSBrickData(BrickVoidChandelierData)
{
	category = "Special";
	subCategory = "Misc";
	uiName = "Void Chandelier";
	brickFile = "./chandelier.blb";
	collisionShapeName = "./chandelier.dts";
	iconName = "Add-Ons/Brick_Void/chandelier";
	canFloatPlant = 1;
	isAdminOnly = 1;
	doQuadBakeLightEffect = 1; //Uses 4x the amount of lights but is great if you arent using many lights
};
function BrickVoidChandelierData::onPlant(%db,%br)
{
	VoidChandelier_BrickEffects(%br);
	parent::onPlant(%db,%br);
}
function BrickVoidChandelierData::onLoadPlant(%db,%br)
{
	VoidChandelier_BrickEffects(%br);
	parent::onLoadPlant(%db,%br);
}
function VoidChandelier_BrickEffects(%br)
{
	if(!isObject(%cleanup = %br.cleanupSet))
		%cleanup = %br.cleanupSet = new simSet();
	%locs = -1;
	%pos = vectorAdd(%br.getPosition(),"0 0 -7.37");
	%loc[%locs++] = vectorAdd(%pos,0 SPC 3.374 SPC 3.4);
	%loc[%locs++] = vectorAdd(%pos,0 SPC -3.374 SPC 3.4);
	%loc[%locs++] = vectorAdd(%pos,3.374 SPC 0 SPC 3.4);
	%loc[%locs++] = vectorAdd(%pos,-3.374 SPC 0 SPC 3.4);
	%loc[%locs++] = vectorAdd(%pos,2.386 SPC 2.386 SPC 2.95);
	%loc[%locs++] = vectorAdd(%pos,-2.386 SPC 2.386 SPC 2.95);
	%loc[%locs++] = vectorAdd(%pos,2.386 SPC -2.386 SPC 2.95);
	%loc[%locs++] = vectorAdd(%pos,-2.386 SPC -2.386 SPC 2.95);
	%locs++;
	for(%i=0;%i<%locs;%i++)
	{
		%emitter = new ParticleEmitterNode() 
		{
			position = %loc[%i];
			scale = "0.01 0.01 0.01";
			dataBlock = "GenericEmitterNode";
			emitter = chandelierFlameEmitter;
		};
		%cleanup.add(%emitter);
	}
	if(%br.getDatablock().doQuadBakeLightEffect)
	{
		%locs = -1;
		%loc[%locs++] = vectorAdd(%pos,0 SPC -1.5 SPC 3);
		%loc[%locs++] = vectorAdd(%pos,0 SPC 1.5 SPC 3);
		%loc[%locs++] = vectorAdd(%pos,-1.5 SPC 0 SPC 3);
		%loc[%locs++] = vectorAdd(%pos,1.5 SPC 0 SPC 3);
		%locs++;
		for(%i=0;%i<%locs;%i++)
		{
			%light = new fxLight()
			{
				datablock = swol_chandelierFakeIllumLight;
				position = %loc[%i];
			};
			%cleanup.add(%light);
		}
	}
	else
	{
		%light = new fxLight()
		{
			datablock = swol_chandelierFakeIllumLight;
			position = vectorAdd(%pos,0 SPC 0 SPC 3);
		};
		%cleanup.add(%light);
	}
}
function fxDTSBrick::swol_checkPlantingError(%temp)
{
	if(%temp.isPlanted())
	{
		error("You must use a temp brick. Not a brick!");
		return -1;
	}
	%brick = new fxDTSBrick()
	{
		datablock = %temp.getDatablock();
		position = %temp.getPosition();
		rotation = %temp.rotation;
		angleID = %temp.angleID;
	};
	%error = %brick.plant();
	%brick.delete();
	switch$(%error)
	{
		case 0: return 0;
		case 1: return "overlap";
		case 2: return "float";
		case 5: return "buried";
	}
}
package swol_brickControl
{
	function serverCmdPlantBrick(%cl)
	{
		%pl = %cl.player;
		%ghost = %pl.tempBrick;
		if(!isObject(%ghost))
			return parent::serverCmdPlantBrick(%cl);
		%db = %ghost.getDatablock();
		if(%db.isAdminOnly)
		{
			if(!%cl.isAdmin)
			{
				messageClient(%cl,'MsgPlantError_Limit');
				centerPrint(%cl,"<br>\c0The Brick \'" @ %db.uiName @ "\' is Super-Admin only",2);
				serverCmdCanccelBrick(%cl);
				return;
			}
		}
		if(%db.canFloatPlant)
		{
			if(%ghost.swol_checkPlantingError() $= "float")
			{
				%brick = new fxDTSBrick()
				{
					position = %ghost.getPosition();
					datablock = %db;
					rotation = %ghost.rotation;
					angleID = %ghost.angleID;
					colorID = %ghost.colorID;
					client = %cl;
					isPlanted = 1;
					scale = %ghost.scale;
					stackBL_ID = %cl.getBLID();
					printID = %ghost.printID;
				};
				%cBrickGroup = "BrickGroup_" @ %cl.getBLID();
				%cBrickGroup.add(%brick);
				%brick.plant();
				%brick.playSound(brickPlantSound);
				%brick.setTrusted(1);
				%cl.undoStack.push(%brick TAB "PLANT");
				%pl.playThread(3,plant);
				return;
			}
			else
			{
				return parent::serverCmdPlantBrick(%cl);
			}
		}
		else
		{
			return parent::serverCmdPlantBrick(%cl);
		}
	}
	function fxDtsBrick::onRemove(%br)
	{
		if(isObject(%cleanup = %br.cleanupSet))
		{
			%i = %cleanup.getCount();
			while(%i-->=0)
				%cleanup.getObject(%i).delete();
			%cleanup.delete();
		}
		return parent::onRemove(%br);
	}
};
activatePackage(swol_brickControl);
datablock fxLightData(swol_chandelierFakeIllumLight)
{
	lightOn = true;
	radius = 7;
	brightness = 3.5*(BrickVoidChandelierData.doQuadBakeLightEffect ? 1 : 4);
	color = "1 0.4 0 1";
	FlareOn			= false;
	FlareTP			= false;
	FlareColor		= "0 0 0";
	ConstantSize	= 1;
	NearSize		= 1;
	FarSize			= 0.5;
	NearDistance	= 30.0;
	FarDistance		= 50.0;
	FadeTime		= 0.01;
};
datablock ParticleData(chandelierFlameParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -0.1;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 600;
	lifetimeVarianceMS   = 200;
	textureName          = "base/data/particles/cloud";
	spinSpeed		   = 0.0;
	spinRandomMin		= 0.0;
	spinRandomMax		= 0.0;
	colors[0]     = "0 0 0.1 0.6";
	colors[1]     = "0.7 0.1 0 0.3";
	colors[2]     = "0.9 0.1 0 0";

	sizes[0]      = 0.2;
	sizes[1]      = 0.3;
	sizes[2]      = 0.1;

	times[0] = 0.1;
	times[1] = 0.4;
	times[2] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(chandelierFlameEmitter)
{
	ejectionPeriodMS = 2;
	periodVarianceMS = 1;
	ejectionVelocity = 0;
	velocityVariance = 0;
	ejectionOffset   = 0.01;
	thetaMin         = 0;
	thetaMax         = 180;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = chandelierFlameParticle;
};